<?php

class StandaloneClass
{
    protected $foo = 'bar';

    public function getFoo ()
    {
        return $this->foo;
    }

    public function setFoo ( $value )
    {
        $this->foo = $foo;
    }
}

class Base
{
    public function __call ( $method, $arguments )
    {
        $type = substr($method, 0, 3);
        $property = substr($method, 3);
        $property[0] = strtolower($property[0]);
        if (property_exists($this, $property))
        {
            switch ($type)
            {
                case 'get':
                    return $this->$property;

                case 'set':
                    $this->$property = $arguments[0];
            }
        }
    }
}

class ExtendedBaseClass extends Base
{
    protected $foo = 'bar';
}


function runTest ( $obj, $repeat = 1000 )
{
    $tests = array();
    $totalTimeStart = microtime(true);
    for ($i=0; $i<$repeat; $i++)
    {
        $start = microtime(true);
        $obj->getFoo();
        $end = microtime(true);
        $tests[] = $end-$start;
    }
    $totalTimeEnd = microtime(true);
    $totalTime = round((($totalTimeEnd - $totalTimeStart) * 10000), 2);
    $avg = 0;
    foreach ($tests as $time)
    {
        $avg += $time;
    }         
    $avg = round(($avg / $repeat * 10000), 5);

    echo 'ran test '.$repeat.' times'."\n".
         'average time is '.$avg.' microseconds'."\n";
}

echo "\n";

$obj = new StandaloneClass();
echo 'StandaloneClass->getFoo() returns "'.$obj->getFoo().'"'."\n";
runTest($obj);

echo "\n";

$obj = new ExtendedBaseClass();
echo 'ExtendedBaseClass->getFoo() returns "'.$obj->getFoo().'"'."\n";
runTest($obj);

echo "\n";
